import { Injectable } from '@angular/core';
import { Http } from '@angular/http';
import { URLSearchParams, RequestOptions, Headers } from '@angular/http';

@Injectable()
export class HttpService {

  constructor(private http: Http, private options: RequestOptions) {
    const headersinfo = new Headers({
      'Cache-Control': 'no-cache',
      'Pragma': 'no-cache',
      'Expires': 'Sat, 01 Jan 2000 00:00:00 GMT',
      'Content-Type': 'application/json'
    });
    this.options = new RequestOptions({ headers: headersinfo });
  }

  httpGetService(uri: string, parms: URLSearchParams) {

    const paramLength = Array.from(parms.paramsMap.values()).length;

    if (paramLength > 0) {
      this.options.params = parms;
      return this.http.get(uri, this.options).map((response => response.json().value));
    }

    return this.http.get(uri, this.options).map((response => response.json().value));
  }

  httpPostService(uri: string, body: any) {
    return this.http.post(uri, body, this.options)
      .map((response => response.json()));
  }

  httpPutService(uri: string, body: any) {
    return this.http.put(uri, body, this.options)
      .map((response => response.json()));
  }
  httpDeleteService(uri: string, body: any) {
    return this.http.delete(uri)
      .map((response => response.json()));
  }
}
