﻿import { Component } from '@angular/core';
import { Router } from '@angular/router';
import { environment } from '../environments/environment';
import { KiewitMenuItem } from '../lib/kiewit-menu/kiewit-menu-item';
import { KiewitAuthenticationService } from '../lib/kiewit-authentication/kiewit-authentication.service';
import { Http, RequestOptions, Headers } from '@angular/http';

@Component({
    selector: 'demo-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.scss'],
    providers: [KiewitAuthenticationService]
})
export class AppComponent {
    menuItems: KiewitMenuItem[];

    constructor(private router: Router, private kiewitAuthentication: KiewitAuthenticationService, private http: Http) {
        this.menuItems = [];
        this.getMenuItems();
    }
    buttonSettingsClick() {
      this.router.navigateByUrl('/userroles');
    }

    public getMenuItems() {
        //let oauthToken = this.kiewitAuthentication.getToken();
        //console.log(this.kiewitAuthentication.getUser());
        const myHeaders = new Headers();
        // myHeaders.append('Authorization', `Bearer ${oauthToken}`);
        const options = new RequestOptions({ headers: myHeaders });

        this.http.get(environment.kcsServiceUrl + 'Menu?$expand=SubItems', options)
            .map(res => <KiewitMenuItem[]>res.json())
            .subscribe(data => {
                this.menuItems = data['value'];
        });
    }

    subMenuOnClick(eventData) {
        const test = eventData.title;
    }
}
