﻿import { Component, OnInit } from '@angular/core';
import { Http, RequestOptions, Headers } from '@angular/http';
import { environment } from '../../../environments/environment';
//import { HttpClient, RequestOptions, Headers } from '@angular/common/http';
import { KiewitCard, OptionsMenuItem, HeaderMenuItem, Highlighter } from '../../../lib/kiewit-card';
import { KiewitLoggingService } from '../../../lib/kiewit-logging/kiewit-logging.service';
import { IKiewitDropdown } from '../../../lib/kiewit-dropdown';
import { IKiewitNumericTextbox } from '../../../lib/kiewit-numerictextbox';
import { InformationType } from '../../../lib/kiewit-toastmessage';
import { Observable } from 'rxjs/Rx';
import { KiewitAuthenticationService } from '../../../lib/kiewit-authentication/kiewit-authentication.service';
import { Router } from '@angular/router';
import {
    GridComponent,
    GridDataResult
    //DataStateChangeEvent
} from '@progress/kendo-angular-grid';

import { SortDescriptor } from '@progress/kendo-data-query';
//import { KiewitAuthenticationService } from '../../../kiewit-authentication/kiewit-authentication.service';

@Component({
    selector: 'app-dashboard',
    templateUrl: './dashboard.component.html',
    styleUrls: ['./dashboard.component.scss'],
    providers: [KiewitLoggingService, KiewitAuthenticationService]
})
export class DashboardComponent implements OnInit {
    private availablecolumnsconfig: any;
    private selectablecolumnsconfig: any;
    constructor(private router: Router, private loggingService: KiewitLoggingService, private kiewitAuthentication: KiewitAuthenticationService, private http: Http) {
    }


    private opprotunitiesConfig: any;
    public IsDashboard = true;

    ngOnInit() {
        //this.opprotunitiesConfig = {
        //    availableColumns: [{ "title": "Tag 3" }, { "title": "ORS Area" }, { "title": "Opt EOJ Gain" }, { "title": "Pess EOJ Gain" }],
        //    selectedColumns: [{ "title": "Win" }, {"title": "Burn Off" }, {"title": "Opportunity Name" }, {"title": "Opportunity ID" }, {"title": "Tag 1" }, {"title": "Tag 2" }],
        //    isOpened: false
        //}
    }

    public KcsApp()
    {
      this.router.navigate(['/userroles'], {
        queryParams: {
          appId: 2,
          userName: 'KiewitUser4@kiewit.com',
          appName:'KCS'
        }, skipLocationChange: true
      });
    }

    public NonKcsApp()
    {
      this.router.navigate(['/userroles'], {
        queryParams: {
          appId: 1,
          userName: 'KiewitUser4@kiewit.com',
          appName: 'BPT'
        }, skipLocationChange: true
      });
    }

    myadal = {
        tenant: 'GEORGE',
        clientId: 'c87f021f-b17e-454d-8303-0c2c07dfaf78'
    };

    public kiewitCardHeaderMenu: HeaderMenuItem[] = [
        {
            'HeaderMenuIconName': 'copyPlan',
            'HeaderMenuIcon': 'fa fa-files-o',
            'HeaderMenuToolTip': 'Copy Plan',
            'HeaderMenuIconHidden': false,
            'HeaderMenuIconDisabled': false
        },
        {
            'HeaderMenuIconName': 'Share',
            'HeaderMenuIcon': 'icon-send',
            'HeaderMenuToolTip': 'Share',
            'HeaderMenuIconHidden': false,
            'HeaderMenuIconDisabled': false
        },
        {
            'HeaderMenuIconName': 'MarkOfficial',
            'HeaderMenuIcon': 'icon-pass-2',
            'HeaderMenuToolTip': 'Mark as Official Plan'
        }
    ];

    public kiewitCardElipsisOptions: OptionsMenuItem[] = [{
        OptionsMenuItemIconToolTip: '',
        OptionsMenuItemIcon: 'icon-print',
        OptionsMenuItemIconHidden: false,
        OptionsMenuItemIconDisabled: false,
        OptionsMenuItemIconTitle: 'item1'
    },
    {
        OptionsMenuItemIconToolTip: '',
        OptionsMenuItemIcon: 'icon-delete',
        //OptionsMenuItemIconHidden: false,
        //OptionsMenuItemIconDisabled: false,
        OptionsMenuItemIconTitle: 'item1'
    },
    {
        OptionsMenuItemIconToolTip: '',
        OptionsMenuItemIcon: 'icon-pass',
        //OptionsMenuItemIconHidden: false,
        //OptionsMenuItemIconDisabled: false,
        OptionsMenuItemIconTitle: 'item1'
    },
    {
        OptionsMenuItemIconToolTip: '',
        OptionsMenuItemIcon: 'icon-remove',
        //OptionsMenuItemIconHidden: false,
        //OptionsMenuItemIconDisabled: false,
        OptionsMenuItemIconTitle: 'item1'
    }
    ];

    public kiewitCardHighlighters: Highlighter[] = [{
        Highlighter: '22m',
        //HighlighterFont: "Roboto",
        //HighlighterFontSize: "28px",
        HighlighterDescription: 'Net Gain',
        //HighlighterDescriptionFont: "Roboto",
        //HighlighterDescriptionFontSize: "12px"
    },
        //{
        //    "Highlighter": "50m",
        //    "HighlighterFont": "Roboto",
        //    "HighlighterFontSize": "28px",
        //    "HighlighterDescription": "Revenue",
        //    "HighlighterDescriptionFont": "Roboto",
        //    "HighlighterDescriptionFontSize": "12px"
        //    }
    ];

    public kiewitCardData: KiewitCard[] = [{
        CardId: 1,
        HeaderMenuItems: this.kiewitCardHeaderMenu,
        Title: 'Project1Project1Project1Project1Project1Project1Project1',
        TagIsOfficialPlan: false,
        TitleDescription1: 'Last Saved 06/05/2017',
        Highlighters: this.kiewitCardHighlighters,
        //OptionsMenuItems: this.kiewitCardElipsisOptions  //Removed more option from Html i.e., elipse
    },
    {
        CardId: 2,
        HeaderMenuItems: this.kiewitCardHeaderMenu,
        Title: 'Project1Project1',
        TagIsOfficialPlan: true,
        TitleDescription1: 'Last Saved 06/05/2017',
        Highlighters: this.kiewitCardHighlighters,
        //OptionsMenuItems: this.kiewitCardElipsisOptions  //Removed more option from Html i.e., elipse
    },
    {
        CardId: 2,
        HeaderMenuItems: this.kiewitCardHeaderMenu,
        Title: 'Project1Project1',
        TagIsOfficialPlan: true,
        TitleDescription1: 'Last Saved 06/05/2017',
        Highlighters: this.kiewitCardHighlighters,
        //OptionsMenuItems: this.kiewitCardElipsisOptions  //Removed more option from Html i.e., elipse
    },
    {
        CardId: 2,
        HeaderMenuItems: this.kiewitCardHeaderMenu,
        Title: 'Project1Project1',
        TagIsOfficialPlan: true,
        TitleDescription1: 'Last Saved 06/05/2017',
        Highlighters: this.kiewitCardHighlighters,
        //OptionsMenuItems: this.kiewitCardElipsisOptions   //Removed more option from Html i.e., elipse
    }];

    public defaultItem: { text: string, value: number } = { text: 'Select item...', value: null };

    public listItems: Array<{ text: string, value: number }> = [
      { text: 'Small', value: 1 },

        { text: 'Medium', value: 2 },
        { text: 'Large', value: 3 }
    ];

    public value = { text: 'Medium', value: 2 };

    public kiewitDropdownConfig = {
        data: [
            { text: 'Small', value: 1 },
            { text: 'Medium', value: 2 },
            { text: 'Large', value: 3 }
        ],
        textField: 'text',
        valueField: 'value',
        //defaultItem: this.defaultItem,
        disabled: true
    };

    //---------grid starts-------------------//

    private pageable = true;
    private sortable = true;
    private filterable = true;
    public view: Observable<GridDataResult>;
    public sort: Array<SortDescriptor> = [];
    public pageSize = 10;
    public skip = 0;

    public header: any = {
        'isExpandRowVisible': false,
        'HiddenHeaderRow': [
            [{
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': '<input type=\'text\' class=\'percentage\' decimal-places=\'3\' name=\'name\' value=\'20%\'  style=\'margin-left: 18px;\'>'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL2'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'Col33'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL4'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL5'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL6'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL7'
            }],
            [{
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': `<span class='up-arrow'></span>
                         <div class='expandline' style='height: 56px;margin-top: -52px;'>&nbsp;</div>
                         <input type='text' class='percentage' decimal-places='3' name='name' value='20%'  style='margin-left: 18px;'>`
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL2'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'Col33'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL4'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL5'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL6'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL7'
            }]
        ]
    };

    public gridData: any[] = [{
        'ProductID': 3,
        'ProductName': 'Aniseed Syrup',
        'SupplierID': 1,
        'CategoryID': 2,
        'QuantityPerUnit': '12 - 550 ml bottles',
        'UnitPrice': 10.0000,
        'UnitsInStock': 13,
        'UnitsOnOrder': 70,
        'ReorderLevel': 25,
        'Discontinued': false,
        'Category': {
            'CategoryID': 2,
            'CategoryName': 'Condiments',
            'Description': 'Sweet and savory sauces, relishes, spreads, and seasonings'
        },
        'isExpandRowVisible': true,
        'HiddenRow': [[
            {
                'colSpan': 1,
                'class': 'expandRowCell',
                'rightMarginWidth': 1,
                'data': 'COL1'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL2'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': '<input type=\'text\' class=\'percentage\' decimal-places=\'3\' name=\'name\' value=\'20%\'  style=\'margin-left: 18px;\'>'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL4'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL5'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL6'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL7'
            }
        ],
        [
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL1'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL2'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': `<span class='up-arrow'></span>
                        <div class='expandline' style='height: 50px;margin-top: -45px;'>&nbsp;</div>
                        <input type='text' class='percentage' decimal-places='3' name='name' value='20%'  style='margin-left: 18px;'>`
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL4'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL5'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL6'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL7'
            }
        ]
        ]
    },
    {
        'ProductID': 3,
        'ProductName': 'Aniseed Syrup',
        'SupplierID': 1,
        'CategoryID': 2,
        'QuantityPerUnit': '12 - 550 ml bottles',
        'UnitPrice': 10.0000,
        'UnitsInStock': 13,
        'UnitsOnOrder': 70,
        'ReorderLevel': 25,
        'Discontinued': false,
        'Category': {
            'CategoryID': 2,
            'CategoryName': 'Condiments',
            'Description': 'Sweet and savory sauces, relishes, spreads, and seasonings'
        },
        'isExpandRowVisible': false,
        'HiddenRow': [[
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL1'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL2'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': `<span class='up-arrow'></span>
                         <div class='expandline' style='height: 25px;'>&nbsp;</div>
                         <input type='text' class='percentage' decimal-places='3' name='name' value='20%'  style='margin-left: 18px;'>`
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL4'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL5'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL6'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL7'
            }
        ]
        ]
    },
    {
        'ProductID': 3,
        'ProductName': 'Aniseed Syrup',
        'SupplierID': 1,
        'CategoryID': 2,
        'QuantityPerUnit': '12 - 550 ml bottles',
        'UnitPrice': 10.0000,
        'UnitsInStock': 13,
        'UnitsOnOrder': 70,
        'ReorderLevel': 25,
        'Discontinued': false,
        'Category': {
            'CategoryID': 2,
            'CategoryName': 'Condiments',
            'Description': 'Sweet and savory sauces, relishes, spreads, and seasonings'
        },
        'isExpandRowVisible': false,
        'HiddenRow': [[
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL1'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': 'COL2'
            },
            {
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': `<span class='up-arrow'></span>
                         <div class='expandline' style='height: 25px;'>&nbsp;</div>
                         <input type='text' class='percentage' decimal-places='3' name='name' value='20%'  style='margin-left: 18px;'>`
            }
        ]
        ]
    }
    ];

    public gridData2: any[] = [{
        'ProductID': 3,
        'ProductName': 'Aniseed Syrup',
        'SupplierID': 1,
        'CategoryID': 2,
        'QuantityPerUnit': '12 - 550 ml bottles',
        'UnitPrice': 10.0000,
        'UnitsInStock': 13,
        'UnitsOnOrder': 70,
        'ReorderLevel': 25,
        'Discontinued': false,
        'Category': {
            'CategoryID': 2,
            'CategoryName': 'Condiments',
            'Description': 'Sweet and savory sauces, relishes, spreads, and seasonings'
        },
        'isExpandRowVisible': true,
        'HiddenRow': [
            [{
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': ''
            },
            {
                'colSpan': 6,
                'class': '',
                'rightMarginWidth': 0,
                'data': `< span class='up-arrow' style="margin-top: 34px;" > </span><div class='expandline' style='height: 48px;margin-top:-11px;'>&nbsp;</div>
                <table style="margin-left: 18px;">
                <tr>
                <td>test < /td>
                < td > test < /td>
                < td > test < /td>
                < td > test < /td>
                < /tr>
                < tr >
                <td>test < /td>
                < td > test < /td>
                < td > test < /td>
                < td > test < /td>
                < /tr>
                < /table>`
            }
            ],
        ]
    },
    {
        'ProductID': 3,
        'ProductName': 'Aniseed Syrup',
        'SupplierID': 1,
        'CategoryID': 2,
        'QuantityPerUnit': '12 - 550 ml bottles',
        'UnitPrice': 10.0000,
        'UnitsInStock': 13,
        'UnitsOnOrder': 70,
        'ReorderLevel': 25,
        'Discontinued': false,
        'Category': {
            'CategoryID': 2,
            'CategoryName': 'Condiments',
            'Description': 'Sweet and savory sauces, relishes, spreads, and seasonings'
        },
        'isExpandRowVisible': false,
        'HiddenRow': [
            [{
                'colSpan': 1,
                'class': '',
                'rightMarginWidth': 1,
                'data': ''
            },
            {
                'colSpan': 6,
                'class': '',
                'rightMarginWidth': 0,
                'data': `<span class='up-arrow' style="margin-top: 34px;"></span><div class='expandline' style='height: 48px;margin-top:-11px;'>&nbsp;</div>
                         <table style="margin-left: 18px;">
                          <tr>
                            <td>test</td>
                            <td>test</td>
                            <td>test</td>
                            <td>test</td>
                          </tr>
                          <tr>
                            <td>test</td>
                            <td>test</td>
                            <td>test</td>
                            <td>test</td>
                          </tr>
                        </table>`
            }
            ],
        ]
    }

    ];
    //---------grid ends-------------------//
    logTrace() {
        this.loggingService.Trace('BPT-App1', 'Test_Method', 'TRACE logging messsage.');
    }

    logDebug() {
        this.loggingService.Debug('BPT-App2', 'Test_Method', 'DEBUG logging messsage.');
    }

    logWarn() {
        this.loggingService.Warn('BPT-App3', 'Test_Method', 'WARN logging messsage.');
    }

    logInfo() {
        this.loggingService.Info('BPT-App4', 'Test_Method', 'INFO logging messsage.');
    }

    logError() {
        this.loggingService.Error('BPT-App5', 'Test_Method', 'ERROR logging messsage.');
    }

    kiewitDropdownOnValueChanged() {
        alert('kiewitDropdownOnValueChanged');
    }

    AddCardClicked() {
        alert('kiewitAddCardClicked');
    }
    CardClicked(event: any) {
        alert('CardClicked');
        console.log(event);
    }
    CardElipsisOptionClick(item: any) {
        alert('CardElipsisOptionClicked' + item);
    }
    CardHeaderMenuIconClicked(iconName: string) {
        alert('CardHeaderMenuIconClicked' + iconName);
    }

    confirmationConfig = {
        isOpened: false,
        title: 'Are you sure you want to delete this row and save any unsaved changes to this tab?',
        yesCaption: 'Yes-Caption',
        noCaption: 'No-Caption',
        isInfoWindow: true
    };

    openConfirmationClick() {
        this.confirmationConfig.isOpened = true;
    }
    columnchooserConfig = {
        //isOpened: false,
        isIconsDisabled: false
    };

    confirmationCloseClicked() {
        alert('confirmationCloseClicked');
    }

    confirmationYesClicked() {
        alert('confirmationYesClicked');
    }

    confirmationNoClicked() {
        alert('confirmationNoClicked');
    }

    padding = 2;
    public data: any[] = [{
        'Id': 1,
        'Title': 'Opportunities',
        'SliderWidth': 180,
        'SliderLeftMargin': 0,
        'Selected': true
    },
    {
        'Id': 2,
        'Title': 'Pending/New Work "Plugs"',
        'SliderWidth': 180,
        'SliderLeftMargin': 180 * 1,
        'Selected': false
    },
    {
        'Id': 3,
        'Title': 'ORS Project tags & Financial Plans',
        'SliderWidth': 180,
        'SliderLeftMargin': 180 * 2,
        'Selected': false
    },
    {
        'Id': 4,
        'Title': 'ORS Off-JOb Financial Plans',
        'SliderWidth': 180,
        'SliderLeftMargin': 180 * 3,
        'Selected': false
    },
    {
        'Id': 5,
        'Title': 'Other Factors',
        'SliderWidth': 180,
        'SliderLeftMargin': 180 * 4,
        'Selected': false
    }
    ];

    public tabstripConfig: any = {
        'data': this.data
    };

    kiewitTabStripClicked(tabData) {
        //alert(tabData.Title);
    }

    getDistricts() {
        const oauthToken = this.kiewitAuthentication.getToken();
        //console.log(this.kiewitAuthentication.getUser());
        const myHeaders = new Headers();
        // myHeaders.append('Authorization', `Bearer ${oauthToken}`);
        const options = new RequestOptions({ headers: myHeaders });

        this.http.get(environment.kcsServiceUrl + 'Districts?$orderby=DISTRICT_DS', options).subscribe(data => {
            console.log(data);
        });
    }

    getUser() {
        const oauthToken = this.kiewitAuthentication.getToken();
        const myHeaders = new Headers();
        myHeaders.append('Authorization', 'Bearer ${oauthToken}');
        const options = new RequestOptions({ headers: myHeaders });

        this.http.get('https://login.microsoftonline.com/common/oauth2/authorize?client_id=' + environment.clientId + '&resource=https://graph.microsoft.com&response_type=token&redirect_uri=' + window.location.origin + '&scope=User.ReadBasic.All', options).subscribe(data => {
            console.log(data);
        });
    }

    kiewitNumericTextboxConfig = {
        spinners: false,
        decimals: 4,
        format: '#.## \\%',
        value: 20,
        maxlength: 5,
        disabled: true
    };

    kiewitNumericTextboxValue = 25;

    kiewitToastMessageConfig = {
      showMessage: false,
        informationMessage: 'Row Successfully Deleted',
        informationType: InformationType.Failure,
        timeOut: 0
    };

    columnchooserCloseClicked() {

    }

    columnChooserClick() {
        this.opprotunitiesConfig = {
            availableColumns: [{ 'title': 'Tag 3' }, { 'title': 'ORS Area' }, { 'title': 'Opt EOJ Gain' }, { 'title': 'Pess EOJ Gain' }],
            selectedColumns: [{ 'title': 'Win' }, { 'title': 'Burn Off' }, { 'title': 'Opportunity Name' }, { 'title': 'Opportunity ID' }, { 'title': 'Tag 1' }, { 'title': 'Tag 2' }],
            isOpened: true
        };
    }
    columnchooserSaveClicked(e: any) {
    }

    buttonManageApplicationClick() {
      console.log('manageapplication');
      this.router.navigate(['/manageapplication'], { skipLocationChange: true });
    }

    buttonManageRolesClick() {

      this.router.navigate(['/manageroles'], { skipLocationChange: true });
    }
}
