import { Injectable } from '@angular/core';
import { URLSearchParams } from '@angular/http';
import { HttpService } from '../../../Common/http.service';
import { FormsModule } from '@angular/forms';
import { environment } from '../../../environments/environment';
import * as config from '../../components/manage-application/config';
import { Observable } from 'rxjs/Observable';

@Injectable()
export class ManageApplicationService {


  constructor(private httpService: HttpService) { }

    getApplication()
    {
      const params = new URLSearchParams();
      return this.httpService.httpGetService(config.uri, params);
    }

    saveApplication(body) {
      const uri = environment.kcsServiceUrl + 'CreateNewApplication';
      return this.httpService.httpPostService(uri, body);
    }

    deleteApplication(appId: number)
    {
      const params = new URLSearchParams();
      return this.httpService.httpDeleteService(config.uri + '(' + appId + ')', params);
    }
    //getProviders()
    //{
    //  const uri = environment.kcsServiceUrl;
    //  const params = new URLSearchParams();
    //  return this.httpService.httpGetService(uri, params);
    //}
}
