import { Component, OnInit, ElementRef, ViewChild } from '@angular/core';
import { IKiewitDropdown } from '../../../lib/kiewit-dropdown';
import { ActivatedRoute, Router } from '@angular/router';
import { UserRolesService } from '../../components/user-roles/user-roles.service';
import { Observable } from 'rxjs/Observable';
import { Ng2AutoCompleteModule } from 'ng2-auto-complete';
@Component({
  selector: 'app-user-roles',
  templateUrl: './user-roles.component.html',
  styleUrls: ['./user-roles.component.scss'],
  providers: [UserRolesService]
})
export class UserRolesComponent implements OnInit {
  public headerValue = 'User Role Mapping';
  public dataItems: any;
  public appsData: Observable<any>;
  public rolesData: Observable<any>;
  public usersData: Observable<any>;
  public selectedApp: any;
  public selectedRole: any;
  public isActive: boolean;
  public selectedUser: any;
  public listformatter: any = 'Name';
  public displaypropertyname: any = 'Name';
  private isDataChanged = true;
  private isRightIconsDisabled = false;
  private roleId: any;
  isUpDownIconDisabled = false;
  isLeftIconsDisabled = false;
  @ViewChild('lstavailable') availablelist: ElementRef;
  @ViewChild('lstselected') selectedlist: ElementRef;
  //Temporarily added - Have to removed in the future
  //public appName = 'BPT1';
  public appName = 'KCS';
  public userName = 'KiewitUser4@kiewit.com';
  public sId = '1';
  //public applicationId = 8;
  public applicationId = 2;
  //Till Here
  public userCount = 0;
  public appId: any;
  public appSelected = false;
  public usersDataConfig: any[];
  private loaderConfig = { isLoading: false };
  private userRolesData: any = {
    availableRoles: [],
    assignedRoles: [],
    isOpened: true
  };
  public appDataConfig =
  {
    data: this.appsData,
    textField: 'Name',
    valueField: 'AppId',
    disabled: false
  };
  constructor(private router: Router, private route: ActivatedRoute, private userRolesService: UserRolesService) {
    //Temporarily added
    this.appName = this.route.snapshot.queryParams['appName'];
    this.userName = this.route.snapshot.queryParams['userName'];
    this.applicationId = Number(this.route.snapshot.queryParams['appId']);
  }

  ngOnInit() {
    this.loaderConfig.isLoading = true;
    //KCS User
    if (this.appName == 'KCS') {
      this.userRolesService.getApplication().subscribe(data => {
        if (data) {
          this.appDataConfig.data = data;
        }
      }, err => this.loaderConfig.isLoading = false);
    } else {// Non KCS User
      this.userRolesService.getApplicationUsers(this.applicationId).subscribe(data => {
        //checking whether the application users are available or not
        if (data) {
          // checking the user who clicked this icon as same person
          this.userRolesService.getApplicationUsersByName(this.applicationId, this.userName).subscribe(data => {
            if(data) {
              this.userCount++;
            }
            if (this.userCount > 0) {
              this.getApplication();
            }
            else {
              alert('You Do not Have Access To This Page');
            }
          });
        }
        else {
          this.userRolesService.saveUsers(this.userName, this.sId).subscribe(data => {
            const userId = data.UserId;
            //add roles to the first user who clicks on settings icon
            this.userRolesService.getRolesByName(this.appName + '_SECURITY_ADMIN').subscribe(data => {
              if (data.length > 0) {
                this.roleId = data[0].RoleId;
                this.userRolesService.saveUserRoles(userId, this.roleId).subscribe(data => {
                });
              }
            });
            this.userRolesService.getRolesByName(this.appName + '_ADMIN').subscribe(data => {
              this.roleId = data[0].RoleId;
              this.userRolesService.saveUserRoles(userId, this.roleId).subscribe(data => {
              });
            });
             
          });
          this.getApplication();
        }
      }, err => this.loaderConfig.isLoading = false);
    }
    this.loaderConfig.isLoading = false;
  }

  getApplication() {
    this.userRolesService.getApplication().subscribe(data => {
      if (data.length > 0) {
        for (let index = 0; index < data.length; index++) {
          if (data[index].Name === this.appName) {
            this.appId = data[index].AppId;
          }
        }
        this.appDataConfig.valueField = 'Name';
        this.appDataConfig.data = data;
        this.selectedApp = this.appName;
        this.appDataConfig.disabled = true;
        this.appSelected = true;
        this.userRolesService.getApplicationRoles(this.appId).subscribe(data => {
          if (data.length > 0) {
            this.userRolesData.availableRoles = data;
          }
          else {
            this.userRolesData.availableRoles = null;
          }
        });
      }
    });
  }

  getApplicationRoles(value) {
    this.appSelected = true;
    this.userRolesService.getApplicationRoles(value.AppId).subscribe(data => {
      if (data.length > 0) {
        this.userRolesData.availableRoles = data;
      }
      else {
        this.userRolesData.availableRoles = null;
      }
    });
  }

  public filterChange(filter: any): void {
    let items = [];
    this.userRolesService.getUserByDisplayName(filter).subscribe((data) => this.dataItems = data);
  }

  //public valueChange(value: any): void {
  //  alert(value);
  //}

  saveUserRoles() {
    // let selectedRoles: any;
    // //TODO : selected user functionality have to be change
    //// this.selectedUser = this.selectedUser = 'Chaitanya.Thalloory@Kiewit.com' ? 2 : 3;
    // for (let index = 0; index < this.userRolesData.assignedRoles.length; index++) {
    //   selectedRoles = selectedRoles + ',' + this.userRolesData.assignedRoles[index].RoleId;
    // }
    // selectedRoles = selectedRoles.substring(1, selectedRoles.length);
    // this.userRolesService.saveUserRoles(selectedRoles, this.selectedUser).subscribe(data => {
    //   if (data.length > 0) {
    //     this.userRolesData.availableRoles = [];
    //     this.userRolesData.assignedRoles = [];

    //   }
    // });
  }

  settingsApplicationClick() {
    if (this.selectedApp != undefined) {
      const mngAppId = this.selectedApp.AppId == undefined ? this.appId : this.selectedApp.AppId;
      this.router.navigate(['/manageapplication'], {
        queryParams: {
          appId: mngAppId,
          ddlStatus: this.appDataConfig.disabled,
          userAppName: this.appName
        }, skipLocationChange: true
      });
    }
  }

  settingsRolesClick() {
    if (this.selectedApp != undefined) {
      const mngAppId = this.selectedApp.AppId == undefined ? this.appId : this.selectedApp.AppId;
      this.router.navigate(['/manageroles'], {
        queryParams: {
          appId: mngAppId,
          ddlStatus: this.appDataConfig.disabled,
          userAppName: this.appName
        }, skipLocationChange: true
      });
    }
  }

  onMoveRight(e: any) {
    if (e.currentTarget.className.indexOf('columnchooser-directional-icons-disabled') != -1) return false;

    const selected = this.getSelectedOptions('AVAILABLE');

    this.isDataChanged = false;
    for (let currentindex = 0; currentindex < selected.length; currentindex++) {
      this.userRolesData.assignedRoles.push(this.userRolesData.availableRoles[selected[currentindex].index]);
    }

    for (let currentindex = 0; currentindex < selected.length; currentindex++) {
      for (let index = 0; index < this.userRolesData.availableRoles.length; index++) {
        if (this.userRolesData.availableRoles[index].Role === selected[currentindex].text) {
          this.userRolesData.availableRoles.splice(index, 1);
          break;
        }
      }
    }

    this.resetIconsToDefault();
  }

  onMoveLeft(e: any) {

    if (e.currentTarget.className.indexOf('columnchooser-directional-icons-disabled') != -1) return false;

    const selected = this.getSelectedOptions('SELECTED');

    this.isDataChanged = false;
    for (let currentindex = 0; currentindex < selected.length; currentindex++) {
      this.userRolesData.availableRoles.push(this.userRolesData.assignedRoles[selected[currentindex].index]);
    }
    for (let currentindex = 0; currentindex < selected.length; currentindex++) {
      for (let index = 0; index < this.userRolesData.assignedRoles.length; index++) {
        if (this.userRolesData.assignedRoles[index].Role === selected[currentindex].text) {
          this.userRolesData.assignedRoles.splice(index, 1);
          break;
        }
      }
    }

    this.resetIconsToDefault();
  }

  onMoveUp(e: any) {
    if (e.currentTarget.className.indexOf('columnchooser-directional-icons-disabled') != -1) return false;
    const selected = this.getSelectedOptions('SELECTED');
    this.isDataChanged = false;
    this.userRolesData.assignedRoles.moveUp(selected[0].index);
  }

  onMoveDown(e: any) {
    if (e.currentTarget.className.indexOf('columnchooser-directional-icons-disabled') != -1) return false;
    const selected = this.getSelectedOptions('SELECTED');
    this.isDataChanged = false;
    this.userRolesData.assignedRoles.moveDown(selected[0].index);
  }

  private getSelectedOptions(type: string) {
    let selectedOptions = [];
    switch (type) {
      case 'AVAILABLE':
        if (this.availablelist.nativeElement.selectedOptions) {
          selectedOptions = this.availablelist.nativeElement.selectedOptions;
        }
        else {
          for (let index = 0; index < this.availablelist.nativeElement.options.length; index++) {
            if (this.availablelist.nativeElement.options[index].selected)
              selectedOptions.push(this.availablelist.nativeElement.options[index]);
          }
        }
        break;
      case 'SELECTED':
        if (this.selectedlist.nativeElement.selectedOptions) {
          selectedOptions = this.selectedlist.nativeElement.selectedOptions;
        }
        else {
          for (let index = 0; index < this.selectedlist.nativeElement.options.length; index++) {
            if (this.selectedlist.nativeElement.options[index].selected)
              selectedOptions.push(this.selectedlist.nativeElement.options[index]);
          }
        }
        break;
      default:
    }

    return selectedOptions;
  }

  private resetIconsToDefault() {
    this.isUpDownIconDisabled = false;
    this.isLeftIconsDisabled = false;
    this.isRightIconsDisabled = false;
  }

  onSelectionChanged(e: any) {

    if (e.target.className === 'selectedList') {
      const selected = this.getSelectedOptions('SELECTED');

      if (selected && selected.length == 1)
        this.isUpDownIconDisabled = true;
      else
        this.isUpDownIconDisabled = false;

      this.isLeftIconsDisabled = true;
      this.isRightIconsDisabled = false;
    }
    else {
      this.isUpDownIconDisabled = false;
      this.isLeftIconsDisabled = false;
      this.isRightIconsDisabled = true;
    }
  }
}

export class User {
  constructor(
    public id: number,
    public name: string) { }
}
