import { Injectable } from '@angular/core';
import { URLSearchParams } from '@angular/http';
import { HttpService } from '../../../Common/http.service';
import { FormsModule } from '@angular/forms';
import { environment } from '../../../environments/environment';

@Injectable()
export class UserRolesService {

  constructor(private httpService: HttpService) { }

  getApplication() {
    const uri = environment.kcsServiceUrl + 'Applications';
    const params = new URLSearchParams();
    return this.httpService.httpGetService(uri, params);
  }

  getApplicationRoles(appId: string) {
    const uri = environment.kcsServiceUrl + 'GetApplicationRolesById(applicationId=' + appId + ')';
    const params = new URLSearchParams();
    return this.httpService.httpGetService(uri, params);
  }

  getUsers() {
    const uri = environment.kcsServiceUrl + 'Users';
    const params = new URLSearchParams();
    return this.httpService.httpGetService(uri, params);
  }

  saveUserRoles(userId: number, roleId: number) {
    const userRole = {
      UserId: userId,
      RoleId: roleId,
      CreatedBy: 'Admin',
      IsActive: true
    };
    const uri = environment.kcsServiceUrl + 'UserRoles';
    return this.httpService.httpPostService(uri, userRole);
  }

  getApplicationUsers(appId: number) {
    const params = new URLSearchParams();
    return this.httpService.httpGetService(environment.kcsServiceUrl + 'GetApplicationUsers(applicationId=' + appId + ')', params);
  }

  getApplicationUsersByName(appId: number, userName: string) {
    const params = new URLSearchParams();
    return this.httpService.httpGetService(environment.kcsServiceUrl + 'GetApplicationUsersByName(applicationId=' + appId + ',userName=\'' + userName + '\')', params);
  }

  saveUsers(userName: string, sId: string) {
    const users = {
      Sid: sId,
      Name: userName,
      Email: userName + '@kiewit.com',
      CreatedDate: '2017-11-27T10:04:51.703Z',
      CreatedBy: 'kiewit.admin@kiewit.com',
      ModifiedBy: 'kiewit.admin@kiewit.com',
      ModifiedDate: '2017-11-27T10:04:51.703Z',
      IsActive: true
    };
    const uri = environment.kcsServiceUrl + 'Users';
    return this.httpService.httpPostService(uri, users);
  }

  getRolesByName(appName: string) {
    const uri = environment.kcsServiceUrl + 'Roles?$filter=Name eq \'' + appName + '\'';
    const params = new URLSearchParams();
    return this.httpService.httpGetService(uri, params);
  }

  getUserByDisplayName(userName: string) {
    const uri = environment.kcsServiceUrl + 'GetUserByDisplayName(displayName=\'' + userName + '\')';
    const params = new URLSearchParams();
    return this.httpService.httpGetService(uri, params);
  }
}

