﻿import { Component, Input, Output, EventEmitter } from '@angular/core';

@Component({
    selector: 'kiewit-confirmation',
    templateUrl: './kiewit-confirmation.component.html',
    styleUrls: ['./kiewit-confirmation.component.css']
})
export class KiewitConfirmationComponent {
    @Input() config: any = {
        isOpened: true,
        title: 'Are you sure want to delete?',
        yesCaption: 'Yes',
        noCaption: 'No',
        isInfoWindow: false
    };

    @Output() kcsClose = new EventEmitter();
    @Output() kcsYes = new EventEmitter();
    @Output() kcsNo = new EventEmitter();

    private closeClicked() {
        this.config.isOpened = false;
        this.kcsClose.emit();
    }

    private yesClicked() {
        this.config.isOpened = false;
        this.kcsYes.emit();
    }

    private noClicked() {
        this.config.isOpened = false;
        this.kcsNo.emit();
    }
}
