﻿import { Component, Input, Output, EventEmitter } from '@angular/core';
import { IKiewitDropdown } from './kiewit-dropdown.interface';

@Component({
  selector: 'kiewit-dropdown',
  templateUrl: './kiewit-dropdown.component.html',
  styleUrls: ['./kiewit-dropdown.component.scss']
})
export class KiewitDropdownComponent {

    @Input() config: IKiewitDropdown = {
        data: [],
        textField: '',
        valueField: '',
    };

  @Input() kcsNgModel: string;
  @Output() kcsNgModelChange = new EventEmitter();
  @Output() kcsValueChange = new EventEmitter();

  onValueChanged(value: any) {
      this.kcsValueChange.emit(value);
  }

  onNgModelChange(newValue) {
      this.kcsNgModel = newValue;
      this.kcsNgModelChange.emit(newValue);
  }

}
