import { Injectable } from '@angular/core';
import { environment } from '../../environments/environment';
import { Observable } from 'rxjs/Rx';
import { HttpService } from '../../Common/http.service';
import { URLSearchParams } from '@angular/http';

@Injectable()
export class KiewitExternalService {

  constructor(private httpService: HttpService) { }

  getDistricts(): Observable<any> {
    const params = new URLSearchParams();
    return this.httpService.httpGetService(environment.kcsServiceUrl + 'Districts?$orderby=DISTRICT_DS', params);
  }

  getMenuItems(): Observable<any> {
    const params = new URLSearchParams();
    return this.httpService.httpGetService(environment.kcsServiceUrl + 'Menu?$expand=SubItems', params);
  }

  //getUserPreferences(): Observable<any> {
  //  const params = new URLSearchParams();
  //  const uri = environment.kcsServiceUrl + "UserPreference?$filter=AppId eq 1 and UserName eq '" + this.commonService.userInfo.username + "' and IsActive eq true&$orderby=UserPreferenceId desc"
  //  return this.httpService.httpGetService(uri, params);
  //}

  addUserPreferences(userPreferenceId, postData): Observable<any> {
    const userPrefData = JSON.stringify(postData);
    if (userPreferenceId > 0)
    {
      return this.httpService.httpPutService(environment.kcsServiceUrl + 'UserPreference(' + userPreferenceId + ')', userPrefData);
    }
    else
    {
      return this.httpService.httpPostService(environment.kcsServiceUrl + 'UserPreference', userPrefData);
    }
  }

  getApplicationHeader() {
    const uri = environment.kcsServiceUrl + 'Applications?$filter=Name eq \'' + environment.app + '\'';
    const params = new URLSearchParams();
    return this.httpService.httpGetService(uri, params);
  }

  getUserProfileByEmail(userMail: string) {
    const params = new URLSearchParams();
    return this.httpService.httpGetService(environment.kcsServiceUrl + 'GetUserProfileByEmail(email=\'' + userMail + '\')', params);
  }
}

