﻿import { Component, Input, Output, OnInit, Inject, ElementRef, ViewChild } from '@angular/core';
import { FormGroup, FormControl, Validators } from '@angular/forms';
import { AddEvent, EditEvent, GridComponent, PageChangeEvent } from '@progress/kendo-angular-grid';
declare var initializeCurrencyTextbox: any;
declare var initializePercentageTextbox: any;

@Component({
    selector: 'kiewit-grid-row-action',
    templateUrl: './kiewit-grid.component.html',
    styleUrls: ['./kiewit-grid.component.scss']
})
export class KiewitGridComponent {
    @Input() public gridData: Object;
    @Input() public dataitem: any;
    private skip = 0;

    protected pageChange({ skip, take }: PageChangeEvent): void {
        this.skip = skip;

    }

    gridExpandclick(event, dataItemOriginal) {
        if (dataItemOriginal.HiddenHeaderRow) {
            const dataItem = dataItemOriginal.HiddenHeaderRow.slice().reverse();
            const target = event.target || event.srcElement || event.currentTarget;
            let nextSibling = target.parentNode.parentNode.parentNode.parentNode.nextSibling;
                if (nextSibling != null && nextSibling.className == 'expandedRow') {
                for (let rowHide = 0; rowHide < dataItem.length; rowHide++) {
                    nextSibling = target.parentNode.parentNode.parentNode.parentNode.nextSibling;
                    target.parentNode.parentNode.parentNode.parentNode.parentNode.removeChild(nextSibling);
                }
            }
            else {
                let r;
                for (let row = 0; row < dataItem.length; row++) {
                    r = document.createElement('tr');
                    r.className = 'expandedRow';
                    for (let c = 0; c < dataItem[row].length; c++) {
                        const col = r.insertCell(c);
                        col.innerHTML = dataItem[row][c].data;
                        col.colSpan = dataItem[row][c].colSpan;
                        col.className = dataItem[row][c].class;
                        //col.style = "border-left-width:" + dataItem[row][c].rightMarginWidth; +"px";
                    }
                    target.parentNode.parentNode.parentNode.parentNode.parentNode.insertBefore(r.cloneNode(true), target.parentNode.parentNode.parentNode.parentNode.nextSibling);
                }
                const classname = document.getElementsByClassName('up-arrow');
                for (let i = 0; i < classname.length; i++) {
                    classname[i].addEventListener('click', this.gridCollapseclick, false);
                }
            }
        }
        if (dataItemOriginal.HiddenRow) {
            const dataItem = dataItemOriginal.HiddenRow.slice().reverse();
            const target = event.target || event.srcElement || event.currentTarget;
            let nextSibling = target.parentNode.parentNode.parentNode.nextSibling;
            if (nextSibling.className == 'expandedRow') {
                for (let rowHide = 0; rowHide < dataItem.length; rowHide++) {
                    nextSibling = target.parentNode.parentNode.parentNode.nextSibling;
                    target.parentNode.parentNode.parentNode.parentNode.removeChild(nextSibling);
                }
            }
            else {
                let r;
                for (let row = 0; row < dataItem.length; row++) {
                    r = document.createElement('tr');
                    r.className = 'expandedRow';
                    for (let c = 0; c < dataItem[row].length; c++) {
                        const col = r.insertCell(c);
                        col.innerHTML = dataItem[row][c].data;
                        col.colSpan = dataItem[row][c].colSpan;
                        col.className = dataItem[row][c].class;
                        //col.style = "border-left-width:" + dataItem[row][c].rightMarginWidth; +"px";
                    }
                    target.parentNode.parentNode.parentNode.parentNode.insertBefore(r.cloneNode(true), target.parentNode.parentNode.parentNode.nextSibling);
                }
                const classname = document.getElementsByClassName('up-arrow');
                for (let i = 0; i < classname.length; i++) {
                    classname[i].addEventListener('click', this.gridCollapseclick, false);
                }
            }
        }

        initializeCurrencyTextbox('.currency');
        initializePercentageTextbox('.percentage');
    }
    gridCollapseclick(event) {
        const target = event.target || event.srcElement || event.currentTarget;
        const allRows = target.parentNode.parentNode.parentNode.children;
        const eleToRemove = [];
        for (let aRow = allRows.length - 1; aRow >= 0; aRow--) {
            if (target.parentNode.parentNode == allRows[aRow]) {
                for (let arRow = aRow ; arRow >= 0; arRow--) {
                    if (allRows[arRow].className == 'expandedRow') {
                        eleToRemove.push(allRows[arRow]);
                    }
                    else {
                        break;
                    }
                }
            }
        }
        for (let aRowRemove = eleToRemove.length - 1; aRowRemove >= 0; aRowRemove--) {
            target.parentNode.parentNode.parentNode.removeChild(eleToRemove[aRowRemove]);
        }
    }
}
