﻿import { Component, Input, Output, EventEmitter } from '@angular/core';
import { IKiewitNumericTextbox } from './kiewit-numerictextbox.interface';
import { FormGroup, FormControl, Validators } from '@angular/forms';

@Component({
    selector: 'kiewit-numerictextbox-grid',
    templateUrl: './kiewit-numerictextbox-grid.component.html',
    styleUrls: ['./kiewit-numerictextbox.component.scss']
})
export class KiewitNumericTextboxGridComponent {

    @Input() config: IKiewitNumericTextbox = {
        spinners: true,
        decimals: 2,
        format: 'a0',
        maxlength: 0,
        min: 0,
        max: 0,
        autoCorrect: false
    };

    @Input() kcsNgModel: string;
    @Output() kcsNgModelChange = new EventEmitter();
    @Output() kcsValueChange = new EventEmitter();
    @Input() kcsFormControl;
    @Output() OnValueChange: EventEmitter<any> = new EventEmitter();
    @Output() OnBlur: EventEmitter<any> = new EventEmitter();

    onValueChanged(value: any) {
        this.kcsValueChange.emit(value);
    }

    onNgModelChange(newValue) {
        this.kcsNgModel = newValue;
        this.kcsNgModelChange.emit(newValue);
    }

    kcsNumFocus(element: any) {
        if (this.config.maxlength > 0)
            element.numericInput.nativeElement.maxLength = this.config.maxlength;
        return false;
    }

    kcsOnValueChange(event) {
        this.OnValueChange.emit(event);
    }

    kcsOnBlur(element: any) {
        this.OnBlur.emit(event);
    }

}
