﻿import { Component, OnInit, Input, Output, EventEmitter, ElementRef, ViewChild, OnChanges } from '@angular/core';

@Component({
    moduleId: module.id,
    selector: 'kiewit-tabstrip',
    templateUrl: './kiewit-tabstrip.component.html',
    styleUrls: ['./kiewit-tabstrip.component.scss']
})
export class KiewitTabStripComponent implements OnInit {

    @ViewChild('slidertab') _sliderTabToAnimate: ElementRef;
    @ViewChild('ul') _ul: ElementRef;

    ngOnChanges() {
        for (var i = 0; i < this.config.data.length; i++) {
            if (this.config.data[i].Selected) {
                this._sliderTabToAnimate.nativeElement.style.marginLeft = this.config.data[i].SliderLeftMargin + 'px';
                this._sliderTabToAnimate.nativeElement.style.width = this.config.data[i].SliderWidth + 'px';
                break;
            }
        }
    }

    @Input() config = {
        data: []
    };

    @Output() kcsTabStripClick: EventEmitter<any> = new EventEmitter();

    ngOnInit() {
        for (var i = 0; i < this.config.data.length; i++) {
            if (this.config.data[i].Selected) {
                this._sliderTabToAnimate.nativeElement.style.marginLeft = this.config.data[i].SliderLeftMargin + 'px';
                this._sliderTabToAnimate.nativeElement.style.width = this.config.data[i].SliderWidth + 'px';
                break;
            }
        }        
    }

    kiewitTabStripClicked(tabData) {
        this._sliderTabToAnimate.nativeElement.style.marginLeft = tabData.SliderLeftMargin + 'px';
        this._sliderTabToAnimate.nativeElement.style.width = tabData.SliderWidth + 'px';
        this.kcsTabStripClick.emit(tabData);
    }
}


