import { Component, OnInit, Input, OnChanges } from '@angular/core';
import { PopupModule } from '@progress/kendo-angular-popup';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { NgModule } from '@angular/core';

@Component({
    selector: 'kiewit-toastmessage',
    templateUrl: './kiewit-toastmessage.component.html',
    styleUrls: ['./kiewit-toastmessage.component.scss']
})
export class KiewitToastmessageComponent implements OnInit, OnChanges {
    @Input() config: any = {
        showMessage: true,
        informationMessage: '',
        informationType: InformationType,
        timeOut: 3000
    };

    private infoClass: string;

    ngOnChanges() {

        if (this.config.showMessage && this.config.timeOut > 0) {
            this.setInfoClass();
            setTimeout(() => {
                this.config.showMessage = false;
            }, this.config.timeOut);
        }
    }

    setInfoClass() {
        switch (this.config.informationType) {
            case InformationType.Success:
                this.infoClass = 'messsageSuccess';
                break;
            case InformationType.Failure:
                this.infoClass = 'messsageFailure';
                break;
            default:
        }
    }

    ngOnInit() {

        this.setInfoClass();

        if (this.config.showMessage && this.config.timeOut > 0)
            setTimeout(() => {
                this.config.showMessage = false;
            }, this.config.timeOut);

    }
}

export enum InformationType {
    Success = 1,
    Failure = 2
}
